import ac
import acsys
import datetime
from TyreBuddy_lib.sim_info import info
from TyreBuddy_lib.buddy_draw_positions import cBuddy_Draw_AppElement_Positions
from TyreBuddy_lib.buddy_draw_slips import cBuddy_Draw_Slips
from TyreBuddy_lib.buddy_draw_tyres import cBuddy_Draw_Tyres, cBuddy_Draw_TyreWarnings

class cBuddy_App():
    #Static Holder
    TyreBuddy = 0

    def __init__(self,Config):
        self.config = Config
        self.mainWindow = 0
        self.mainWindow_Label = ""
        self.mainWindow_QuadsLabel = ""
        self.mainWindow_PageSpinner = ""
        self.PageIndex = -1
        self.PageIndex_Last = -2
        
        self.BuddyDrive = 0
        self.BuddyTyres = 0
        self.BuddyFuel = 0

        self.BuddyDrive_Positions = 0
        self.BuddyDraw_Slips = [0] * 2
        self.BuddyDraw_Tyres = 0
        
        self.ButtonMode = 0

        self.FONTS_LOADED = {}

    def createWindow(self):
        self.mainWindow = ac.newApp(self.config.app_name)
        lSize = 13 * self.config.Resolution
        ac.setSize(self.mainWindow, self.config.app_width, self.config.app_height + lSize )
        ac.setIconPosition(self.mainWindow, 0, -10000)
        ac.setTitle(self.mainWindow,"")
        #ac.setTitle(self.mainWindow, self.config.app_name)

        self.mainWindow_Label = ac.addLabel(self.mainWindow,"")
        ac.setPosition(self.mainWindow_Label, 250, 5)

        #DO NOT REMOVE THIS INVISIBLE LABEL OTHERWISE QUADS STOPS WORKING
        #AND THE GUAGE BARS & SLIPS METER VANISH!
        self.mainWindow_QuadsLabel = ac.addLabel(self.mainWindow," ")
        ac.setPosition(self.mainWindow_QuadsLabel, 0, 0)

        self.mainWindow_ButtonLeft = ac.addButton(self.mainWindow,"")
        self.mainWindow_ButtonRight = ac.addButton(self.mainWindow,"")
        self.mainWindow_ButtonMode = ac.addButton(self.mainWindow,"")
        ac.addOnClickedListener(self.mainWindow_ButtonLeft,cBuddy_App.mainWindow_Static_ButtonLeft_Click)
        ac.addOnClickedListener(self.mainWindow_ButtonRight,cBuddy_App.mainWindow_Static_ButtonRight_Click)
        ac.addOnClickedListener(self.mainWindow_ButtonMode,cBuddy_App.mainWindow_Static_ButtonMode_Click)
        ac.drawBorder(self.mainWindow_ButtonLeft,0)
        ac.drawBorder(self.mainWindow_ButtonRight,0)
        ac.setBackgroundOpacity(self.mainWindow_ButtonLeft,0)
        ac.setBackgroundOpacity(self.mainWindow_ButtonRight,0)
        ac.setBackgroundTexture(self.mainWindow_ButtonLeft,"apps\python\TyreBuddy\TyreBuddy_img\ArrowLeft.png")
        ac.setBackgroundTexture(self.mainWindow_ButtonRight,"apps\python\TyreBuddy\TyreBuddy_img\ArrowRight.png")

        #ac.setBackgroundTexture(self.mainWindow, "apps/python/OptimiseTyres/res/main_background.png")

    def PositionButtons(self):
        lButtonWidth  = self.BuddyDrive_Positions.BuddyMode_Button.Width  #18 * self.config.Resolution
        lButtonHeight = self.BuddyDrive_Positions.BuddyMode_Button.Height #5 * self.config.Resolution
        #lButtonTop = self.config.app_height + (self.config.app_height * 0.02 )
        lButtonTop = self.BuddyDrive_Positions.BuddyMode_Button.Top
        lButtonLeft = self.config.app_width - ( self.BuddyDrive_Positions.BuddyMode_Button.Width * 2 ) - ( self.config.app_height * 0.04 )
        lButtonRight = self.config.app_width - self.BuddyDrive_Positions.BuddyMode_Button.Width - ( self.config.app_height * 0.03 )
        lButtonMode = self.BuddyDrive_Positions.BuddyMode_Button.Left
        ac.setSize(self.mainWindow_ButtonLeft, lButtonWidth, lButtonHeight)
        ac.setSize(self.mainWindow_ButtonRight, lButtonWidth, lButtonHeight)
        ac.setSize(self.mainWindow_ButtonMode, lButtonWidth, lButtonHeight)
        ac.setPosition(self.mainWindow_ButtonLeft, lButtonLeft, lButtonTop)
        ac.setPosition(self.mainWindow_ButtonRight, lButtonRight, lButtonTop)
        ac.setPosition(self.mainWindow_ButtonMode, lButtonMode, lButtonTop)
        

    #static functions
    def mainWindow_Static_ButtonLeft_Click(x,y):
        self = cBuddy_App.TyreBuddy.BuddyApp
        if self.ButtonMode == 0:
            self.config.Navigate("Page",-1)
        elif self.ButtonMode == 1:
            self.config.Navigate("OptimalSpread",-1)
            lOptimalSpread_front, lOptimalSpread_rear = self.config.IMOSpreads.Spread
            self.BuddyTyres.updateOptimalSpread(lOptimalSpread_front,lOptimalSpread_rear)
        elif self.ButtonMode == 2:
            self.config.Navigate("IMOStance",-1)
            lOptimalSpread_front, lOptimalSpread_rear = self.config.IMOSpreads.Spread
            self.BuddyTyres.updateOptimalSpread(lOptimalSpread_front,lOptimalSpread_rear)
        elif self.ButtonMode == 3:
            self.config.Navigate("Wear",-1)
            self.BuddyDrive_Positions.Position_UpdateWearOnTyres(int(self.config.WearLevels))

        return 1

    def mainWindow_Static_ButtonRight_Click(x,y):
        self = cBuddy_App.TyreBuddy.BuddyApp
        if self.ButtonMode == 0:
            self.config.Navigate("Page",1)
        elif self.ButtonMode == 1:
            self.config.Navigate("OptimalSpread",1)
            lOptimalSpread_front, lOptimalSpread_rear = self.config.IMOSpreads.Spread
            self.BuddyTyres.updateOptimalSpread(lOptimalSpread_front,lOptimalSpread_rear)
        elif self.ButtonMode == 2:
            self.config.Navigate("IMOStance",1)
            lOptimalSpread_front, lOptimalSpread_rear = self.config.IMOSpreads.Spread
            self.BuddyTyres.updateOptimalSpread(lOptimalSpread_front,lOptimalSpread_rear)
        elif self.ButtonMode == 3:
            self.config.Navigate("Wear",1)
            self.BuddyDrive_Positions.Position_UpdateWearOnTyres(int(self.config.WearLevels))

        return 1

    def mainWindow_Static_ButtonMode_Click(x,y):
        self = cBuddy_App.TyreBuddy.BuddyApp
        self.ButtonMode += 1
        if self.ButtonMode > 3:
            self.ButtonMode = 0
        return 1

    def setup(self,TyreBuddyApp):
        #update static reference to tyrebuddy for static functions
        #this is a complete botch job but it's limitation of AC
        #thankfully we only ever have one instance of BuddyApp so no problems!
        cBuddy_App.TyreBuddy = TyreBuddyApp
        self.BuddyDrive = TyreBuddyApp.BuddyDrive
        self.BuddyTyres = TyreBuddyApp.BuddyTyres
        self.BuddyFuel  = TyreBuddyApp.BuddyFuel

        self.BuddyDrive_Positions = cBuddy_Draw_AppElement_Positions(self.mainWindow,self.config.Resolution,0,0,self.config.app_width,self.config.app_height)
        self.BuddyDrive_Positions.Position_UpdateWearOnTyres(int(self.config.WearLevels))
        
        self.BuddyDraw_Tyres = cBuddy_Draw_Tyres(self.config,self.BuddyDrive_Positions)
        self.BuddyDraw_Tyres.setup(self.BuddyTyres.Tyres)

        self.BuddyDraw_Slips = [ \
             cBuddy_Draw_Slips( self.BuddyDrive_Positions.Position_Slips_Front ) \
            ,cBuddy_Draw_Slips( self.BuddyDrive_Positions.Position_Slips_Rear ) \
            ]

        self.PositionButtons()
        
        self.FONTS_LOADED["aria"] = ac.initFont(0,"aria",0,0)

    def DrawSlips(self):
        self.BuddyDraw_Slips[0].draw(self.BuddyTyres.Slips_Front_DIFF)
        self.BuddyDraw_Slips[1].draw(self.BuddyTyres.Slips_Rear_DIFF)

    def DrawTyres(self):
        self.BuddyDraw_Tyres.DrawAll()

    def DrawElementPositions(self):
        self.BuddyDrive_Positions.DrawAllElements(1,0,0,0,0,0,1)

    def write_debug_text(self):
        lMessages = [""] * 6
        lN = 0
        
        lCHK_Stablity = 0
        lCHK_PSIs = 0
        
        lConfigPage = -1+int(self.config.BuddyPage)
        lForcePage = lConfigPage

        if lConfigPage == -1 and self.PageIndex_Last != -1:
            self.PageIndex_Last = -1
            return
        elif lConfigPage != -1 and lConfigPage != self.PageIndex_Last:
            self.PageIndex_Last = lConfigPage
        if self.BuddyDrive.Distance_KMsToGo == 0:
            for n in range(4):
                lCHK_Stablity += self.BuddyTyres[n].Temp_AVG_2km_ThermallyStable
                lCHK_PSIs += round(abs(self.BuddyTyres[n].Temp_PSI_Recommendation),1)

        lPage = 0
        if (lCHK_Stablity != 4 and lForcePage == 0) or lForcePage == 1:
            lPage = 1
        elif (lCHK_PSIs > 0 and lForcePage == 0) or lForcePage == 2:
            lPage = 2
        elif lForcePage in [0,3]:
            lPage = 3
        elif lForcePage == 4:
            lPage = 4

        if self.ButtonMode == 0:
            lModeText = "{}".format(str(self.config.BuddyPage))
            ac.setText(self.BuddyDrive_Positions.BuddyMode.Label,lModeText)
            lDriveText = ""
            if lPage == 4:
                FuelMax = str(int(round(self.BuddyFuel.MaxFuel,0)))
                FuelCurrent = str(round(self.BuddyFuel.Fuel,1))
                lDriveText = "{}/{}L".format(FuelCurrent,FuelMax)
            elif lPage > 0 and self.BuddyDrive.Distance_KMsToGo > 0:
                lDriveText = "Drive: {}kms".format(self.BuddyDrive.Distance_KMsToGo)
            ac.setText(self.BuddyDrive_Positions.Drive.Label,lDriveText)
            ac.setText(self.BuddyDrive_Positions.BuddySettings.Label,"")
        elif self.ButtonMode == 1:
            ac.setText(self.BuddyDrive_Positions.BuddyMode.Label,"")
            ac.setText(self.BuddyDrive_Positions.Drive.Label,"")
            lText = "{} {}°C".format(str(self.config.IMOSpreads),float(self.config.IMOSpreads))
            ac.setText(self.BuddyDrive_Positions.BuddySettings.Label,lText)
        elif self.ButtonMode == 2:
            ac.setText(self.BuddyDrive_Positions.BuddyMode.Label,"")
            ac.setText(self.BuddyDrive_Positions.Drive.Label,"")
            imospread = float(self.config.IMOSpreads)
            front,rear = self.config.IMOSpreads.IMOStance.Stance
            lStance = "{}/{}°C".format(front*imospread,rear*imospread)
            lText = "{} {}".format(str(self.config.IMOSpreads.IMOStance),lStance)
            ac.setText(self.BuddyDrive_Positions.BuddySettings.Label,lText)
        elif self.ButtonMode == 3:
            ac.setText(self.BuddyDrive_Positions.BuddyMode.Label,"")
            ac.setText(self.BuddyDrive_Positions.Drive.Label,"")
            lText = "Wear Levels: {}".format(str(self.config.WearLevels))
            ac.setText(self.BuddyDrive_Positions.BuddySettings.Label,lText)
        else:
            ac.setText(self.BuddyDrive_Positions.BuddyMode.Label,"")
            ac.setText(self.BuddyDrive_Positions.Drive.Label,"")
            ac.setText(self.BuddyDrive_Positions.BuddySettings.Label,"")

        #if on the Tyre Wear Page: Put Tyre Wear into DEMO MODE
        self.BuddyDraw_Tyres.Wear_Demo = (self.ButtonMode == 3)

        wear = info.physics.tyreWear

        for lN in range(4):
            lLabelOne   = self.BuddyDrive_Positions.Position_Tyres[lN].Labels[0]
            lLabelTwo   = self.BuddyDrive_Positions.Position_Tyres[lN].Labels[1]
            lLabelThree = self.BuddyDrive_Positions.Position_Tyres[lN].Labels[2]
            lTyre = self.BuddyTyres[lN]
            
            lLabel1 = ""
            lLabel2 = ""
            lLabel3 = ""
            
            if lPage == 1:
                lLabel1 = "{}°C".format(int(round(lTyre.Temp_AVG,0)))
                lLabel2 = "{}-{}°C".format(self.config.Car_CurrentTyres_OptimalCold,self.config.Car_CurrentTyres_OptimalHot)
                lLabel3 = "±{}°C".format(round(lTyre.Temp_AVG_2km_Diff,1))
            elif lPage == 2:
                lKMsOnTyres = "{}km".format(round(lTyre.Meters_Driven/1000,1))
                lLabel1 = "{}°C".format(int(round(lTyre.Temp_AVG,0)))
                lLabel2 = lKMsOnTyres if lTyre.Temp_PSI_Recommendation == 0 else (("add " if lTyre.Temp_PSI_Recommendation > 0 else "sub ") + str(abs(lTyre.Temp_PSI_Recommendation)) + "PSI")
                lLabel3 = "±{}°C".format(round(lTyre.Temp_AVG_2km_Diff,1))
            elif lPage == 3:
                lTyreIM = round(lTyre.Temp_IM_Diff,1)
                lTyreMO = round(lTyre.Temp_MO_Diff,1)
                if (lTyreIM * lTyreMO) > 0: ## if both are positive or negative just take the one that's highest
                    lTyreTotal = max(abs(lTyreIM),abs(lTyreMO))
                else:
                    lTyreTotal = round(lTyreIM - lTyreMO,1)
                lLabel1 = "{}°C".format(lTyreTotal)
                lLabel2 = "{}°C".format(lTyreMO)
                lLabel3 = "{}°C".format(lTyreIM)
            elif lPage == 4:
                TrackGrip = self.config.TrackGripLevel
                TyreGrip =  (self.BuddyTyres[lN].Wear / 100)
                CornerGrip = str(int(round(TrackGrip * TyreGrip * 100,0)))
                lLabel2 = '{}%'.format(CornerGrip)
                if lN == 0:
                    FuelPerLap = str(round(self.BuddyFuel.FuelPerLap,1))
                    if self.BuddyFuel.FuelPerLap > 0:
                        lLabel1 = '{} L/Lap'.format(FuelPerLap)
                    else:
                        lLabel1 = '--- L/Lap'

                    if self.BuddyFuel.FuelPerLap > 0 and self.BuddyFuel.LapsRemaining < 2:
                        lLabel3 = 'PIT PIT'
                elif lN == 1:
                    LapsRemaining = str(round(self.BuddyFuel.LapsRemaining,1))
                    NextRefuelLitres = self.BuddyFuel.NextRefuelLitres
                    if self.BuddyFuel.FuelPerLap > 0:
                        lLabel1 = '{} Laps'.format(LapsRemaining)
                    else:
                        lLabel1 = '--- Laps'

                    if NextRefuelLitres >= 0:
                        lLabel3 = '{}L'.format(NextRefuelLitres)
                    else:
                        lLabel3 = '---'
                elif lN == 2:
                    FuelPerMin = str(round(self.BuddyFuel.FuelPerMinute,1))
                    if self.BuddyFuel.FuelPerLap > 0:
                        lLabel1 = '{} L/Min'.format(FuelPerMin)
                    else:
                        lLabel1 = '--- L/Min'

                    if self.BuddyFuel._OnLap:
                        lLabel3 = "Rec..."
                    else:
                        lLabel3 = "---"
                elif lN == 3:
                    MinutesRemaining, SecondsRemaining = divmod(self.BuddyFuel.MinutesRemaining*60, 60)
                    HoursRemaining, MinutesRemaining = divmod(MinutesRemaining, 60)
                    TimeRemaining = '{:02d}:{:02d}:{:02d}'.format(int(HoursRemaining), int(MinutesRemaining), int(SecondsRemaining))
                    RefuelLitres = self.BuddyFuel.RefuelLitres
                    if self.BuddyFuel.FuelPerLap > 0:
                        lLabel1 = TimeRemaining
                    else:
                        lLabel1 = '--:--:--'

                    if RefuelLitres >= 0:
                        lLabel3 = '{}L'.format(RefuelLitres)
                    else:
                        lLabel3 = '---'

            ac.setText(lLabelOne,lLabel1)
            ac.setText(lLabelTwo,lLabel2)
            ac.setText(lLabelThree,lLabel3)
