import ac
import acsys
import math

class cBuddy_Draw_Window_Position:
    def __init__(self,Left,Top,Width,Height,InnerWidth=0):
        self.Left = math.trunc(Left)
        self.Top = math.trunc(Top)
        self.Width = math.trunc(Width)
        self.Height = math.trunc(Height)
        self.Right = math.trunc(Left + Width)
        self.Bottom = math.trunc(Top + Height)
        self.Center = round( (self.Left + self.Right) / 2 , 0)
        self.Middle = round( (self.Top + self.Bottom) / 2 , 0)
        if InnerWidth>0:
            self.InnerWidth = InnerWidth
            self.InnerHeight = self.Height - ( InnerWidth * 2 )
            self.InnerLeft = self.Left + InnerWidth
            self.InnerRight = self.Right - InnerWidth
            self.InnerTop = self.Top + InnerWidth
            self.InnerBottom = self.Bottom  - InnerWidth

class cBuddy_Draw_AppElement_Positions:
    def __init__(self,mainWindow,Resolution,Left,Top,Width,Height):
        self.MainWindow = mainWindow
        self.Resolution = Resolution
        self.Left = Left
        self.Top = Top
        self.Width = Width
        self.Height = Height
        self.Right = Left + Width
        self.Bottom = Top + Height

        self.BuddyMode_Button = cBuddy_Draw_Window_Position( \
              self.Left + ( self.Height * 0.02 ) \
            , self.Bottom - ( self.Height * 0.06 ) + ( self.Height * 0.06 ) \
            , ( self.Width / 10 ) - ( self.Height * 0.04 ) \
            , self.Height * 0.06 \
            )
        self.Drive = cBuddy_Draw_Window_Position( \
              self.BuddyMode_Button.Right + ( self.Height * 0.015 ) \
            , self.Bottom - ( self.Height * 0.06 ) + ( self.Height * 0.03 ) \
            , self.Width  \
            , self.BuddyMode_Button.Height \
            )
        self.Drive.Label = self.Position_TyreText_CreateLabel(self.Drive,"Left",0.5)
        self.BuddyMode = cBuddy_Draw_Window_Position( \
              self.Drive.Left \
            , self.Drive.Top \
            , self.Width - ( self.Height * 0.42 ) \
            , 10          \
            )
        self.BuddyMode.Label = self.Position_TyreText_CreateLabel(self.BuddyMode,"Right",0.5)
        self.BuddySettings = cBuddy_Draw_Window_Position( \
              self.Drive.Left  \
            , self.Drive.Top \
            , self.Width - ( self.Height * 0.42 )  \
            , 10          \
            )
        self.BuddySettings.Label = self.Position_TyreText_CreateLabel(self.BuddySettings,"Center",0.5)

        self.Position_Slips_Front = cBuddy_Draw_Window_Position( \
              self.Left + ( self.Height * 0.02 ) \
            , self.Top + ( self.Height * 0.02 ) \
            , self.Width - ( self.Height * 0.04 ) \
            , self.Height * 0.04 \
            )

        self.Position_Slips_Rear = cBuddy_Draw_Window_Position( \
              self.Left + ( self.Height * 0.02 ) \
            , self.Bottom - ( self.Height * 0.06 ) \
            , self.Width - ( self.Height * 0.04 ) \
            , self.Height * 0.04 \
            )

        self.Position_Tyres = [0,0,0,0]
        self.Position_Tyres[0] = cBuddy_Draw_Window_Position( \
              self.Left + ( self.Height * 0.025 ) \
            , self.Top + ( self.Height * 0.08 ) \
            , ( self.Width / 2 ) - ( self.Height * 0.09 ) \
            , ( self.Height / 2 ) - ( self.Height * 0.10 ) \
            )

        self.Position_Tyres[1] = cBuddy_Draw_Window_Position( \
              self.Left + ( self.Width / 2 ) + ( self.Height * 0.055 ) \
            , self.Top + ( self.Height * 0.08 ) \
            , ( self.Width / 2 ) - ( self.Height * 0.09 ) \
            , ( self.Height / 2 ) - ( self.Height * 0.10 ) \
            )

        self.Position_Tyres[2] = cBuddy_Draw_Window_Position( \
              self.Left + ( self.Height * 0.025 ) \
            , self.Top + ( self.Height / 2 ) + ( self.Height * 0.02 ) \
            , ( self.Width / 2 ) - ( self.Height * 0.09 ) \
            , ( self.Height / 2 ) - ( self.Height * 0.10 ) \
            )

        self.Position_Tyres[3] = cBuddy_Draw_Window_Position( \
              self.Left + ( self.Width / 2 ) + ( self.Height * 0.055 ) \
            , self.Top + ( self.Height / 2 ) + ( self.Height * 0.02 ) \
            , ( self.Width / 2 ) - ( self.Height * 0.09 ) \
            , ( self.Height / 2 ) - ( self.Height * 0.10 ) \
            )
        self.Position_AddIconsToTyres()
        self.Position_AddTextToTyres()
        self.Position_UpdateWearOnTyres(2)

        self.Position_Gauges = [0,0,0,0]
        self.Position_Gauges[0] = cBuddy_Draw_Window_Position( \
              self.Left + ( self.Width / 2 ) - ( self.Height * 0.065 ) \
            , self.Top + ( self.Height * 0.08 ) \
            , ( self.Height * 0.05 ) \
            , ( self.Height / 2 ) - ( self.Height * 0.10 ) \
            , 1 \
            )
        self.Position_Gauges[1] = cBuddy_Draw_Window_Position( \
              self.Left + ( self.Width / 2 ) + ( self.Height * 0.015 ) \
            , self.Top + ( self.Height * 0.08 ) \
            , ( self.Height * 0.05 ) \
            , ( self.Height / 2 ) - ( self.Height * 0.10 ) \
            , 1 \
            )
        self.Position_Gauges[2] = cBuddy_Draw_Window_Position( \
              self.Left + ( self.Width / 2 ) - ( self.Height * 0.065 ) \
            , self.Top + ( self.Height / 2 ) + ( self.Height * 0.02 ) \
            , ( self.Height * 0.05 ) \
            , ( self.Height / 2 ) - ( self.Height * 0.10 ) \
            , 1 \
            )
        self.Position_Gauges[3] = cBuddy_Draw_Window_Position( \
              self.Left + ( self.Width / 2 ) + ( self.Height * 0.015 ) \
            , self.Top + ( self.Height / 2 ) + ( self.Height * 0.02 ) \
            , ( self.Height * 0.05 ) \
            , ( self.Height / 2 ) - ( self.Height * 0.10 ) \
            , 1 \
            )

    def Position_UpdateWearOnTyres(self,Weights=0):
        lBarThickness = 1 * self.Resolution

        Heights = [0.2,0.3,0.3,0.20]
        if Weights == 1:
            Heights = [0.2,0.4,0.2,0.20]
        elif Weights == 2:
            Heights = [0.2,0.5,0.15,0.15]
        
        for n in range(4):
            lTyre = self.Position_Tyres[n]
            if n % 2 == 0: # left
                lLeft = lTyre.Left - lBarThickness
            else: # right
                lLeft = lTyre.Right - lBarThickness
            
            Tops = [0,0,0,0]
            Tops[1] = Heights[0]
            Tops[2] = Tops[1] + Heights[1]
            Tops[3] = Tops[2] + Heights[2]
            
            lTyre.Wear = [ \
                  cBuddy_Draw_Window_Position( \
                      lLeft \
                    , lTyre.Top + (lTyre.Height * Tops[0]) + 1 \
                    , ( lBarThickness * 2 ) + 1 \
                    , lTyre.Height * Heights[0] \
                    ) \
                , cBuddy_Draw_Window_Position( \
                      lLeft \
                    , lTyre.Top + (lTyre.Height * Tops[1]) \
                    , ( lBarThickness * 2 ) + 1 \
                    , lTyre.Height * Heights[1] \
                    ) \
                , cBuddy_Draw_Window_Position( \
                      lLeft \
                    , lTyre.Top + (lTyre.Height * Tops[2]) \
                    , ( lBarThickness * 2 ) + 1 \
                    , lTyre.Height * Heights[2] \
                    ) \
                , cBuddy_Draw_Window_Position( \
                      lLeft \
                    , lTyre.Top + (lTyre.Height * Tops[3]) \
                    , ( lBarThickness * 2 ) + 1 \
                    , ( lTyre.Height * Heights[3] ) - 1 \
                    ) \
                ]

    def Position_AddIconsToTyres(self):
        lWidth = 20 * self.Resolution
        lHeight = 20 * self.Resolution
        lPadding = ( self.Height * 0.02 )
        for n in range(4):
            lTyre = self.Position_Tyres[n]
            lTop = lTyre.Bottom - lPadding - lHeight
            if n % 2 == 0: # left
                lLeftOne = lTyre.Right - lPadding - lWidth
                lLeftTwo = lLeftOne - lPadding - lWidth
            else: # right
                lLeftOne = lTyre.Left + lPadding
                lLeftTwo = lLeftOne + lPadding + lWidth
            lTyre.Icons = [ \
                  cBuddy_Draw_Window_Position( \
                      lLeftOne \
                    , lTop \
                    , lWidth \
                    , lHeight \
                    ) \
                , cBuddy_Draw_Window_Position( \
                      lLeftTwo \
                    , lTop \
                    , lWidth \
                    , lHeight \
                    ) \
                ]
        return

    def Position_AddTextToTyres(self):
        lWidth = ( self.Height * 0.28 )
        lHeight = 15 * self.Resolution
        lPadding = ( self.Height * 0.02 )
        vPadding = ( self.Height * 0.005 )
        for n in range(4):
            lTyre = self.Position_Tyres[n]
            lTop1 = lTyre.Top + vPadding
            lTop2 = lTyre.Bottom - vPadding - lHeight
            if n % 2 == 0: # left
                lLeftOne = lTyre.Left + lPadding
                lLeftTwo = lTyre.Right - lPadding - lWidth
                lAlignOuter = "Left"
                lAlignInner = "Right"
            else: # right
                lLeftOne = lTyre.Right - lPadding - lWidth
                lLeftTwo = lTyre.Left + lPadding
                lAlignOuter = "Right"
                lAlignInner = "Left"
            lTyre.TextLabels = [ \
                  cBuddy_Draw_Window_Position( \
                      lLeftOne \
                    , lTop1 \
                    , lWidth \
                    , lHeight \
                    ) \
                , cBuddy_Draw_Window_Position( \
                      lLeftOne \
                    , lTop2 \
                    , lWidth \
                    , lHeight \
                    ) \
                , cBuddy_Draw_Window_Position( \
                      lLeftTwo \
                    , lTop1 \
                    , lWidth \
                    , lHeight \
                    ) \
                ]
            lTyre.Labels = [0,0,0]
            lTyre.Labels[0] = self.Position_TyreText_CreateLabel(lTyre.TextLabels[0],lAlignOuter)
            lTyre.Labels[1] = self.Position_TyreText_CreateLabel(lTyre.TextLabels[1],lAlignOuter)
            lTyre.Labels[2] = self.Position_TyreText_CreateLabel(lTyre.TextLabels[2],lAlignInner)
        return

    def Position_TyreText_CreateLabel(self,LabelPosition,AlignOuter,TextSize=1):
        lLabel = ac.addLabel(self.MainWindow,"")
        ac.setPosition(lLabel,LabelPosition.Left,LabelPosition.Top)
        ac.setSize(lLabel,LabelPosition.Width,LabelPosition.Height)
        ac.setCustomFont(lLabel,"aria",0,0)
        ac.setFontColor(lLabel,1,1,1,1)
        lResolution = self.Resolution # * TextSize
        ac.setFontSize(lLabel,12 * lResolution)
        ac.setFontAlignment(lLabel,AlignOuter.lower())
        ac.setBackgroundColor(lLabel,0,0,0)
        ac.setBackgroundOpacity(lLabel,0)
        ac.setVisible(lLabel,1)
        return lLabel

    #use this to draw all the elements
    def DrawAllElements(self,DrawBorder,DrawSlips,DrawTyres,DrawGauges,DrawIcons,DrawText,Black):
        if DrawBorder == 1:
            cBuddy_Draw_AppElement_Positions.DrawBox(self.Left,self.Top,self.Width,self.Height,1,Black)

        if DrawSlips == 1:
            cBuddy_Draw_AppElement_Positions.DrawBox( \
                  self.Position_Slips_Front.Left   \
                , self.Position_Slips_Front.Top    \
                , self.Position_Slips_Front.Width  \
                , self.Position_Slips_Front.Height \
                , 1 \
                , 0 \
                )
            cBuddy_Draw_AppElement_Positions.DrawBox( \
                  self.Position_Slips_Rear.Left   \
                , self.Position_Slips_Rear.Top    \
                , self.Position_Slips_Rear.Width  \
                , self.Position_Slips_Rear.Height \
                , 1 \
                , 0 \
                )

        if DrawIcons == 1:
            for n in range(4):
                cBuddy_Draw_AppElement_Positions.DrawBox( \
                      self.Position_Tyres[n].Icons[0].Left   \
                    , self.Position_Tyres[n].Icons[0].Top    \
                    , self.Position_Tyres[n].Icons[0].Width  \
                    , self.Position_Tyres[n].Icons[0].Height \
                    , 1 \
                    , 0 \
                    )
                cBuddy_Draw_AppElement_Positions.DrawBox( \
                      self.Position_Tyres[n].Icons[1].Left   \
                    , self.Position_Tyres[n].Icons[1].Top    \
                    , self.Position_Tyres[n].Icons[1].Width  \
                    , self.Position_Tyres[n].Icons[1].Height \
                    , 1 \
                    , 0 \
                    )

        if DrawText == 1:
            for n in range(4):
                cBuddy_Draw_AppElement_Positions.DrawBox( \
                      self.Position_Tyres[n].TextLabels[0].Left   \
                    , self.Position_Tyres[n].TextLabels[0].Top    \
                    , self.Position_Tyres[n].TextLabels[0].Width  \
                    , self.Position_Tyres[n].TextLabels[0].Height \
                    , 1 \
                    , 0 \
                    )
                cBuddy_Draw_AppElement_Positions.DrawBox( \
                      self.Position_Tyres[n].TextLabels[1].Left   \
                    , self.Position_Tyres[n].TextLabels[1].Top    \
                    , self.Position_Tyres[n].TextLabels[1].Width  \
                    , self.Position_Tyres[n].TextLabels[1].Height \
                    , 1 \
                    , 0 \
                    )
                cBuddy_Draw_AppElement_Positions.DrawBox( \
                      self.Position_Tyres[n].TextLabels[2].Left   \
                    , self.Position_Tyres[n].TextLabels[2].Top    \
                    , self.Position_Tyres[n].TextLabels[2].Width  \
                    , self.Position_Tyres[n].TextLabels[2].Height \
                    , 1 \
                    , 0 \
                    )

        if DrawTyres == 0 and DrawGauges == 0:
            return

        for n in range(4):
            if DrawTyres == 1:
                cBuddy_Draw_AppElement_Positions.DrawBox( \
                      self.Position_Tyres[n].Left   \
                    , self.Position_Tyres[n].Top    \
                    , self.Position_Tyres[n].Width  \
                    , self.Position_Tyres[n].Height \
                    , 1 \
                    , 0 \
                    )
            if DrawGauges == 1:
                cBuddy_Draw_AppElement_Positions.DrawBox( \
                      self.Position_Gauges[n].Left   \
                    , self.Position_Gauges[n].Top    \
                    , self.Position_Gauges[n].Width  \
                    , self.Position_Gauges[n].Height \
                    , 1 \
                    , 0 \
                    )

    def DrawBox(Left,Top,Width,Height,BarSize,Black):
        Right = Left + Width
        Bottom = Top + Height
        InnerLeft = Left + BarSize
        InnerRight = Right - BarSize
        InnerTop = Top + BarSize
        InnerBottom = Bottom - BarSize

        ac.glBegin(acsys.GL.Quads)
        if Black == 1:
            ac.glColor4f(0,0,0,1)
        else:
            ac.glColor4f(1,1,1,1)
        ac.glVertex2f(Left ,Top)
        ac.glVertex2f(Right,Top)
        ac.glVertex2f(Right,Bottom)
        ac.glVertex2f(Left ,Bottom)

        ac.glColor4f(0,0,0,1)
        ac.glVertex2f(InnerLeft ,InnerTop)
        ac.glVertex2f(InnerRight,InnerTop)
        ac.glVertex2f(InnerRight,InnerBottom)
        ac.glVertex2f(InnerLeft ,InnerBottom)
        ac.glEnd()

