import ac
import acsys

class cBuddy_Draw_Tyre:
    def __init__(self,Config,Position_Tyre,Tyre):
        self.Config = Config
        self.Position_Tyre = Position_Tyre
        self.Tyre = Tyre
        self.MultiColourBar = False
        return

    def getIMOLineColour(self,IMO_COLOURS,Temp_Diff):
        rgb = [0,0,0,1]

        for n in range(3):
            rgb[n] = IMO_COLOURS[n].Translate(Temp_Diff)
        
        return rgb

    def drawIMO(self):
        lIM_Top = self.Position_Tyre.Top + ( self.Position_Tyre.Height * ( 1 - (self.Tyre.Temp_IM_Percentage) ) )
        lMO_Top = self.Position_Tyre.Top + ( self.Position_Tyre.Height * ( 1 - (self.Tyre.Temp_MO_Percentage) ) )
        
        if (self.Tyre.Side != 1): ## left side
            lIMSide = self.Position_Tyre.Right
            lMOSide = self.Position_Tyre.Left
        else:
            lIMSide = self.Position_Tyre.Left
            lMOSide = self.Position_Tyre.Right
        if self.Tyre.foreaft != 1: ## front
            IMLineColour = self.getIMOLineColour(self.Config.TYRE_IMO_COLOURS_FRONT,self.Tyre.Temp_IM_Diff)
            MOLineColour = self.getIMOLineColour(self.Config.TYRE_IMO_COLOURS_FRONT,self.Tyre.Temp_MO_Diff*-1)
        else:
            IMLineColour = self.getIMOLineColour(self.Config.TYRE_IMO_COLOURS_REAR,self.Tyre.Temp_IM_Diff)
            MOLineColour = self.getIMOLineColour(self.Config.TYRE_IMO_COLOURS_REAR,self.Tyre.Temp_MO_Diff*-1)
            
        lBarThickness = 2 * self.Config.Resolution
        
        ## PINK LINE
        if self.Config.MedianLine.upper() == "WHITE":
            ac.glColor4f(1,1,1,1)
        else:
            ac.glColor4f(1,0,1,0.5)
        ac.glBegin(acsys.GL.Quads)
        ac.glVertex2f(lMOSide,lMO_Top+lBarThickness)
        ac.glVertex2f(lMOSide,lMO_Top-lBarThickness)
        ac.glVertex2f(lIMSide,lIM_Top-lBarThickness)
        ac.glVertex2f(lIMSide,lIM_Top+lBarThickness)
        ac.glEnd()
        
        ## IM LINE
        ac.glColor4f(*IMLineColour)
        ac.glBegin(acsys.GL.Quads)
        ac.glVertex2f(lIMSide,lIM_Top+lBarThickness)
        ac.glVertex2f(lIMSide,lIM_Top-lBarThickness)
        ac.glVertex2f(self.Position_Tyre.Center,self.Position_Tyre.Middle-lBarThickness)
        ac.glVertex2f(self.Position_Tyre.Center,self.Position_Tyre.Middle+lBarThickness)
        ac.glEnd()
        
        ## MO LINE
        ac.glColor4f(*MOLineColour)
        ac.glBegin(acsys.GL.Quads)
        ac.glVertex2f(lMOSide,lMO_Top+lBarThickness)
        ac.glVertex2f(lMOSide,lMO_Top-lBarThickness)
        ac.glVertex2f(self.Position_Tyre.Center,self.Position_Tyre.Middle-lBarThickness)
        ac.glVertex2f(self.Position_Tyre.Center,self.Position_Tyre.Middle+lBarThickness)
        ac.glEnd()

    def drawWear(self,Demo_Mode):
        ## WEAR LINE
        lWear = self.Tyre.Wear
        NeedsWearIn = self.Tyre.NeedsWearIn
        lWearMeter = []
        lWearMeter.append(((min(max(lWear,99.0),100.0) - 99.0)))
        lWearMeter.append(((min(max(lWear,95.0),99.0) - 95.0)/4))
        lWearMeter.append(((min(max(lWear,92.0),95.0) - 92.0)/3))
        lWearMeter.append(((min(max(lWear,80.0),92.0) - 80.0)/12))
        lGreen = 0.5 + ((1-lWearMeter[1])/2)
        lGreen2 = lGreen if lWearMeter[2] == 1 else lWearMeter[2]

        for n in range(4):
            lDraw = False
            if Demo_Mode:
                lDraw = True
                lWearPerc = 0
                if n == 0:
                    ac.glColor4f(0,1,0,1)
                elif n == 1:
                    ac.glColor4f(0,0.5,0,1)
                elif n == 2:
                    ac.glColor4f(1,1,0,1)
                elif n == 3:
                    ac.glColor4f(1,0,0,1)
            else: # Demo Mode
                if n == 0 and lWear >= 99.0: #first 10%
                    lDraw = True
                    if lWear == 100:
                        ac.glColor4f(0.77,1.0,0,1)
                        lWearPerc = 0
                    else:
                        lWearPerc = 1-lWearMeter[0]
                        ac.glColor4f(0,1,0,1)
                elif n == 1 and lWear >= 95.0: # Top half
                    lDraw = True
                    lWearPerc = 1-lWearMeter[1]
                    ac.glColor4f(0,0.5,0,1)
                elif n == 2 and lWear >= 92.0:
                    lDraw = True
                    lWearPerc = 1-lWearMeter[2]
                    if lWear < 95.0 or lWearMeter[1]<1:
                        ac.glColor4f(1-lWearMeter[1],lGreen,0,1)
                elif n == 3:
                    lDraw = True
                    lWearPerc = 1-lWearMeter[3]
                    if lWear < 92.0 or lWearMeter[2]<1:
                        ac.glColor4f(1,lGreen2,0,1)

            if lDraw:
                lTop = self.Position_Tyre.Wear[n].Top + (self.Position_Tyre.Wear[n].Height * lWearPerc)
                lBottom = self.Position_Tyre.Wear[n].Bottom
                lLeft = self.Position_Tyre.Wear[n].Left
                lRight = self.Position_Tyre.Wear[n].Right
                ac.glBegin(acsys.GL.Quads)
                ac.glVertex2f(lLeft,lTop)
                ac.glVertex2f(lRight,lTop)
                ac.glVertex2f(lRight,lBottom)
                ac.glVertex2f(lLeft,lBottom)
                ac.glEnd()

class cBuddy_Draw_TyreWarnings:
    icons = [0,0,0,0,0,0]
    icons[0] = ac.newTexture("apps\python\TyreBuddy\TyreBuddy_img\cold.png")
    icons[1] = ac.newTexture("apps\python\TyreBuddy\TyreBuddy_img\hot2.png")
    icons[2] = ac.newTexture("apps\python\TyreBuddy\TyreBuddy_img\TiSsm_10km.png")
    icons[3] = ac.newTexture("apps\python\TyreBuddy\TyreBuddy_img\TiSsm.png")
    icons[4] = ac.newTexture("apps\python\TyreBuddy\TyreBuddy_img\ArrowLeft.png")
    icons[5] = ac.newTexture("apps\python\TyreBuddy\TyreBuddy_img\ArrowRight.png")

    def __init__(self,Config,Position_Tyre,Tyre):
        self.Config = Config
        self.Position_Tyre = Position_Tyre
        self.Tyre = Tyre
        self.TempIcon = 0
        return

    def drawWarnings(self):
        ac.glColor4f(1,1,1,1) #true colour images
        lStabilityWarning = self.Position_Tyre.Icons[0]
        lTempWarning = self.Position_Tyre.Icons[1]

        if self.Tyre.Temp_AVG > self.Config.Absolute_Hottest:
            self.TempIcon = 2
        elif self.Tyre.Temp_AVG > self.Config.Absolute_HotWarning:
            self.TempIcon = 1
        elif self.Tyre.Temp_AVG > self.Config.OptimalHot:
            self.TempIcon = 0.5
        elif self.Tyre.Temp_AVG < self.Config.Absolute_ColdWarning:
            self.TempIcon = -1
        elif self.Tyre.Temp_AVG < self.Config.OptimalCold:
            self.TempIcon = -0.5
        else:
            self.TempIcon = 0
        
        if self.TempIcon == 2: ## hottest
            ac.glQuadTextured( \
                 lTempWarning.Left   \
                ,lTempWarning.Top    \
                ,lTempWarning.Width  \
                ,lTempWarning.Height \
                ,cBuddy_Draw_TyreWarnings.icons[1] \
                )
        elif self.TempIcon == -1 : #cold
            ac.glQuadTextured( \
                 lTempWarning.Left   \
                ,lTempWarning.Top    \
                ,lTempWarning.Width  \
                ,lTempWarning.Height \
                ,cBuddy_Draw_TyreWarnings.icons[0] \
                )

        #no temperature warnings and maintained less than 5°C variation in the last 2km of driving
        if self.Tyre.Temp_AVG_DrivingRequired > 0:
            ac.glQuadTextured( \
                 lStabilityWarning.Left   \
                ,lStabilityWarning.Top    \
                ,lStabilityWarning.Width  \
                ,lStabilityWarning.Height \
                ,cBuddy_Draw_TyreWarnings.icons[2] \
                )
        elif self.Tyre.Temp_AVG_2km_ThermallyStable == 0:
            ac.glQuadTextured( \
                 lStabilityWarning.Left   \
                ,lStabilityWarning.Top    \
                ,lStabilityWarning.Width  \
                ,lStabilityWarning.Height \
                ,cBuddy_Draw_TyreWarnings.icons[3] \
                )

class cBuddy_Draw_Gauge:
    def __init__(self,Config,Position_Gauge,Tyre):
        self.Config = Config
        self.Position_Gauge = Position_Gauge
        self.Tyre = Tyre
        return

    def GetTyreTempColour(self,Temp_AVG):
        rgb = [0,0,0,1]

        for n in range(3):
            rgb[n] = self.Config.TYRE_TEMP_COLOURS[n].Translate(Temp_AVG)
        return rgb

    def drawTempGuage(self):
        lRGB = self.GetTyreTempColour(self.Tyre.Temp_AVG)
        
        ac.glBegin(acsys.GL.Quads)

        ac.glColor4f(1,1,1,1) #White guage back ground
        ac.glVertex2f(self.Position_Gauge.Left ,self.Position_Gauge.Top)
        ac.glVertex2f(self.Position_Gauge.Right,self.Position_Gauge.Top)
        ac.glVertex2f(self.Position_Gauge.Right,self.Position_Gauge.Bottom)
        ac.glVertex2f(self.Position_Gauge.Left ,self.Position_Gauge.Bottom)
        
        ac.glColor4f(*lRGB) #Colour of Guage
        ac.glVertex2f(self.Position_Gauge.InnerRight,self.Position_Gauge.InnerBottom)
        ac.glVertex2f(self.Position_Gauge.InnerLeft ,self.Position_Gauge.InnerBottom)
        ac.glVertex2f(self.Position_Gauge.InnerLeft ,self.Position_Gauge.InnerTop)
        ac.glVertex2f(self.Position_Gauge.InnerRight,self.Position_Gauge.InnerTop)

        ac.glEnd()
        
        lMidPoint_Percent = self.Tyre.Temp_IMO_MidPoint_Smooth_AVG
        if abs(lMidPoint_Percent) >= 0.15:
            ac.glBegin(acsys.GL.Quads)
            #constrain MidPoint to +/-1°C and half it to get a percent of the height
            #only show the pressure bar if there's a problem
            ac.glColor4f(0,0,0,1) #Black PSI Indicator
            lMidPoint_Top = self.Position_Gauge.InnerHeight * (lMidPoint_Percent / 2)
            ac.glVertex2f(self.Position_Gauge.InnerRight,self.Position_Gauge.Middle+lMidPoint_Top)
            ac.glVertex2f(self.Position_Gauge.InnerLeft ,self.Position_Gauge.Middle+lMidPoint_Top)
            ac.glVertex2f(self.Position_Gauge.InnerLeft ,self.Position_Gauge.Middle)
            ac.glVertex2f(self.Position_Gauge.InnerRight,self.Position_Gauge.Middle)
            ac.glEnd()


class cBuddy_Draw_Tyres:
    def __init__(self,Config,AppElements_Positions):
        self.Config = Config
        self.Position_Tyres = AppElements_Positions.Position_Tyres
        self.Position_Gauges = AppElements_Positions.Position_Gauges
        self.Tyres = 0
        self.IMOGraph = [0]*4
        self.TyreWarnings = [0]*4
        self.GaugeBars = [0]*4
        self.Loaded = 0
        self.Wear_Demo = False

    def setup(self,Tyres):
        self.Tyres = Tyres
        for n in range(4):
            self.IMOGraph[n] = cBuddy_Draw_Tyre(self.Config,self.Position_Tyres[n],self.Tyres[n])
            self.TyreWarnings[n] = cBuddy_Draw_TyreWarnings(self.Config,self.Position_Tyres[n],self.Tyres[n])
            self.GaugeBars[n] = cBuddy_Draw_Gauge(self.Config,self.Position_Gauges[n],self.Tyres[n])
        self.Loaded = 1

    def DrawAll(self):
        if self.Loaded == 0:
            return
        for n in range(4):
            self.drawTyre_MiddleLines(self.Position_Tyres[n])
            self.IMOGraph[n].drawIMO()
            self.TyreWarnings[n].drawWarnings()
            self.drawTyre_Window(self.Position_Tyres[n])
            self.GaugeBars[n].drawTempGuage()
            self.IMOGraph[n].drawWear(self.Wear_Demo)

    def drawTyre_MiddleLines(self,WindowPosition):
        #draw middle lines
        ac.glColor4f(1,1,1,0.25)
        cBuddy_Draw_Tyres.DrawLine(WindowPosition.Left,WindowPosition.Middle,WindowPosition.Right,WindowPosition.Middle,0,1)
        cBuddy_Draw_Tyres.DrawLine(WindowPosition.Center,WindowPosition.Top,WindowPosition.Center,WindowPosition.Bottom,1,0)

    def drawTyre_Window(self,WindowPosition):
        #draw outer box
        ac.glColor4f(1,1,1,1)
        cBuddy_Draw_Tyres.DrawLine(WindowPosition.Left,WindowPosition.Top,WindowPosition.Right,WindowPosition.Top,0,1)
        cBuddy_Draw_Tyres.DrawLine(WindowPosition.Left,WindowPosition.Bottom,WindowPosition.Right,WindowPosition.Bottom,0,-1)
        cBuddy_Draw_Tyres.DrawLine(WindowPosition.Left,WindowPosition.Top,WindowPosition.Left,WindowPosition.Bottom,1,0)
        cBuddy_Draw_Tyres.DrawLine(WindowPosition.Right,WindowPosition.Top,WindowPosition.Right,WindowPosition.Bottom,1,0)

    def DrawLine(x1,y1,x2,y2,w,h):
        ac.glBegin(acsys.GL.Quads)
        ac.glVertex2f(x1 ,y1)
        ac.glVertex2f(x2 ,y2)
        ac.glVertex2f(x2+w,y2+h)
        ac.glVertex2f(x1+w,y1+h)
        ac.glEnd()
