import ac
from TyreBuddy_lib.sim_info import info
from TyreBuddy_lib.beancounter import cBeanCounter
from TyreBuddy_lib.buddy_events import cEvents

class cBuddy_Drive(cEvents):
    def __init__(self,Config):
        super().__init__()
        self.Config = Config
        self.CarName = ""
        self.Car_CurrentTyres_Tyre = ""
        self.Car_CurrentTyres_Compound = ""
        self.DistanceLast = cBuddy_Drive.GetDistanceTraveled()
        self.Distance_KMsToGo = 0
        self.ThermalStability_Distance_Full = 0
        self.ThermalStability_Distance_Short = 0
        self.inPitLane = -9
        self.inBox = -9
        self.isDriving = 1
        self.LapsCompleted = 0
        self.CreateEvent("PitLane_Enter"  )
        self.CreateEvent("PitLane_Exit"   )
        self.CreateEvent("Box_Enter"      )
        self.CreateEvent("Box_Exit"       )
        self.CreateEvent("New_Lap"        )
        self.CreateEvent("New_Tyres"      )
        self.CreateEvent("Driving_Started")
        self.CreateEvent("Driving_Stopped")
        self.CreateEvent("Driving"        )
        
        self.setup(Config)

    def setup(self,Config):
        self.ThermalStability_Distance_Full = Config.Warm_Up_KMs
        self.ThermalStability_Distance_Short = Config.After_Spin_KMs
        self.Distance_KMsToGo = Config.Warm_Up_KMs
        self.LapsCompleted = info.graphics.completedLaps

    #return distance traveled in KM rounded to nearest 100 meters
    def GetDistanceTraveled():
        return round(info.graphics.distanceTraveled / 1000,1)

    def ResetDistanceRequired(self,ResetToFull,ResetToShort):
        if ResetToFull:
            self.Distance_KMsToGo = self.ThermalStability_Distance_Full
        elif ResetToShort and self.Distance_KMsToGo < self.ThermalStability_Distance_Short:
            self.Distance_KMsToGo = self.ThermalStability_Distance_Short

    def CheckTyres(self):
        lChanged = 0
        lCarName = ac.getCarName(0)
        lCompound = ac.getCarTyreCompound(0) ## SHORT NAME
        if not self.CarName == lCarName:
            self.CarName = lCarName
            self.Car_CurrentTyres_Tyre = info.graphics.tyreCompound
            self.Car_CurrentTyres_Compound = lCompound
            lChanged = 1
        elif not self.Car_CurrentTyres_Compound == lCompound:
            self.Car_CurrentTyres_Tyre = info.graphics.tyreCompound
            self.Car_CurrentTyres_Compound = lCompound
            lChanged = 1
        
        if lChanged == 1:
            self.RaiseEvent("New_Tyres", { "CarName":lCarName , "Compound":lCompound } )
            self.Distance_OnCurrentTyres = 0

    def update(self):
        if self.isDriving != 1 and round(info.physics.speedKmh,0) > 0:
            self.isDriving = 1
            self.RaiseEvent("Driving_Started")
        elif self.isDriving != 0 and round(info.physics.speedKmh,0) == 0:
            self.isDriving = 0
            self.RaiseEvent("Driving_Stopped")

        if self.inBox != info.graphics.isInPit:
            self.inBox = info.graphics.isInPit
            if self.inBox:
                self.RaiseEvent("Box_Enter")
            else:
                self.RaiseEvent("Box_Exit")

        if self.inPitLane != info.graphics.isInPitLane:
            self.inPitLane = info.graphics.isInPitLane
            if self.inPitLane:
                self.RaiseEvent("PitLane_Enter")
            else:
                self.RaiseEvent("PitLane_Exit")

        if self.LapsCompleted != info.graphics.completedLaps:
            self.LapsCompleted = info.graphics.completedLaps
            self.RaiseEvent("New_Lap")

        newDistance = cBuddy_Drive.GetDistanceTraveled()
        if self.DistanceLast == newDistance:
            return

        lDistanceDiff = newDistance - self.DistanceLast
        self.DistanceLast = newDistance

        self.Distance_KMsToGo = round(max(min(self.Distance_KMsToGo - lDistanceDiff,self.ThermalStability_Distance_Full),0),1)

        self.RaiseEvent("Driving")
