import math
from TyreBuddy_lib.sim_info import info
from TyreBuddy_lib.CAC import cCAC
from TyreBuddy_lib.sim_info import info
from TyreBuddy_lib.beancounter import cBeanCounter

class cBuddy_Tyre:
    def __init__(self,Bean_2km_Size,Bean_MidPoint_Smooth_Size,TyreText,TyreCorner,isRear,isRightSide,OptimalSpread,Thermal_Stability_Temps):
        self.TyreText = TyreText
        self.Tyre = TyreCorner ## CAC.tyre_corner
        self.foreaft = isRear
        self.Side = isRightSide
        
        self.LastDistance = self.distanceTraveled_Meters
        self.Wear = 0
        self.NewTyre = False
        self.Meters_Driven = 0
        self.NeedsWearIn = False
        self.Pressure = 0
        self.Slip = 0
        self.Temp_Core = 0
        self.Temp_AVG = 0
        
        self.OptimalSpread = OptimalSpread
        self.Half_OptimalSpread = OptimalSpread / 2
        self.Thermal_Stability_Temps = Thermal_Stability_Temps # array [°C on, °C off]
        self.Thermal_Stability_On = self.Thermal_Stability_Temps[0]
        self.Thermal_Stability_Off = self.Thermal_Stability_Temps[1]
        self.OptimalCold = 0
        self.OptimalHot = 0
        self.TempIcon = 2
        
        self.Temp_IMO = [0,0,0]
        self.Temp_IM_Diff = 0
        self.Temp_MO_Diff = 0
        self.Temp_IMO_MidPoint = 0
        self.Temp_IM_Diff_Constrained = 0
        self.Temp_MO_Diff_Constrained = 0
        self.Temp_IM_Percentage = 0
        self.Temp_MO_Percentage = 0
        
        self.Temp_AVG_DrivingRequired = 0
        self.Temp_AVG_2km_ThermallyStable = 0
        self.Temp_AVG_2km_Diff = 0
        self.Temp_AVG_2km = [0]*Bean_2km_Size
        
        self.Temp_IMO_MidPoint_Smooth = [0]*Bean_MidPoint_Smooth_Size
        self.Temp_IMO_MidPoint_Smooth_Full = 0
        self.Temp_IMO_MidPoint_Smooth_AVG = 0
        
        self.Temp_PSI_Recommendation = 0
        self.PSI_Warning = 0
        self.MidPoint_Index = 0

    @property
    def distanceTraveled_Meters(self):
        return round(info.graphics.distanceTraveled,0)

    @property
    def TyreRate(self):
        if self.Tyre in[0,1]:
            return info.static.aidTireRate
        else:
            return info.static.aidTireRate

    @property
    def trackLengthKM(self):
        if self.Tyre in[0,1]:
            return info.static.trackSPlineLength / 1000
        else:
            return info.static.trackSPlineLength / 1000

    @property
    def Meters_Driven_Adjusted(self):
        return self.Meters_Driven * self.TyreRate

    def NewTyres(self):
        self.Meters_Driven = 0
        self.LastDistance = self.distanceTraveled_Meters
        self.NeedsWearIn = round(info.physics.tyreWear[self.Tyre],1) < 100

    def update(self,MidPoint_Bean,MidPoint_Index):
        lWear = round(info.physics.tyreWear[self.Tyre],1)
        speedKmh = round(info.physics.speedKmh,0)
        lWearDiff = round(abs(self.Wear - lWear),2)
        self.Wear = lWear
        self.NewTyre = (lWearDiff >= 0.1 and speedKmh <= 5) # tyre wear changed 0.1% in one update
        
        if self.NewTyre:
            self.NewTyres()
        else:
            lNewDistance = self.distanceTraveled_Meters
            lDiff_Meters = round(lNewDistance - self.LastDistance,2)
            self.Meters_Driven += lDiff_Meters
            self.LastDistance = lNewDistance
        
        self.Pressure = round(info.physics.wheelsPressure[self.Tyre],1)
        self.Slip = round(info.physics.wheelSlip[self.Tyre],2)
        self.Temp_Core = round(info.physics.tyreCoreTemperature[self.Tyre],1)
        
        self.Temp_IMO[cCAC.TEMP_MIDDLE] = round(info.physics.tyreTempM[self.Tyre],1)
        #for some reason, temp values in/out is swapped on left side tyres
        if (self.Side == cCAC.LEFTSIDE): ## left side
            self.Temp_IMO[cCAC.TEMP_INNER] = round(info.physics.tyreTempO[self.Tyre],3)
            self.Temp_IMO[cCAC.TEMP_OUTER] = round(info.physics.tyreTempI[self.Tyre],3)
        else:
            self.Temp_IMO[cCAC.TEMP_INNER] = round(info.physics.tyreTempI[self.Tyre],3)
            self.Temp_IMO[cCAC.TEMP_OUTER] = round(info.physics.tyreTempO[self.Tyre],3)
            
        #75% of the core + 25% of the surface
        self.Temp_AVG = (self.Temp_Core*0.75)+((sum(self.Temp_IMO)/3)*0.25)
        
        self.Temp_IM_Diff = self.Temp_IMO[cCAC.TEMP_INNER] - self.Temp_IMO[cCAC.TEMP_MIDDLE]
        self.Temp_MO_Diff = self.Temp_IMO[cCAC.TEMP_OUTER] - self.Temp_IMO[cCAC.TEMP_MIDDLE]
        self.Temp_IMO_MidPoint = round( (( self.Temp_IM_Diff + self.Temp_MO_Diff ) / 2),3) ## mid point °C should be zero

        lNalf_OptimalSpread = self.Half_OptimalSpread * - 1
        self.Temp_IM_Diff_Constrained = min(max(self.Temp_IM_Diff,lNalf_OptimalSpread),self.Half_OptimalSpread)
        self.Temp_MO_Diff_Constrained = min(max(self.Temp_MO_Diff,lNalf_OptimalSpread),self.Half_OptimalSpread)
        
        self.Temp_IM_Percentage = ( self.Temp_IM_Diff_Constrained + self.Half_OptimalSpread ) / ( self.OptimalSpread + 0.001 )
        self.Temp_MO_Percentage = ( self.Temp_MO_Diff_Constrained + self.Half_OptimalSpread ) / ( self.OptimalSpread + 0.001 )


        if MidPoint_Bean:
            self.MidPoint_Index = MidPoint_Index
            lLenSmooth = len(self.Temp_IMO_MidPoint_Smooth)
            self.Temp_IMO_MidPoint_Smooth[MidPoint_Index] = self.Temp_IMO_MidPoint

            #constrain MidPoint to +/-1°C and half it to get a percent of the height
            self.Temp_IMO_MidPoint_Smooth_Full = sum(self.Temp_IMO_MidPoint_Smooth) / lLenSmooth
            self.Temp_IMO_MidPoint_Smooth_AVG = min(max(self.Temp_IMO_MidPoint_Smooth_Full,-1),1)
            if self.PSI_Warning != 0 and (-0.15 < self.Temp_IMO_MidPoint_Smooth_AVG < 0.15):
                self.PSI_Warning = 0
            elif self.PSI_Warning != -1 and self.Temp_IMO_MidPoint_Smooth_AVG > 0.2:
                self.PSI_Warning = -1 # PSI LOW
            elif self.PSI_Warning != 1 and self.Temp_IMO_MidPoint_Smooth_AVG < -0.2:
                self.PSI_Warning = 1 # PSI HIGH

            #estimate every 0.2°C is 1psi - it's only accurate up to 5°C so no point in using Smooth_Full
            #chop off the decimal places, we only want to give recomendations for FULL PSI increments
            self.Temp_PSI_Recommendation = int(math.trunc(self.Temp_IMO_MidPoint_Smooth_AVG*5))

    #record the tyre temps every 100 meters so they can be averaged
    #this way we can see if the tyres are thermally stable over a distance
    def UpdateAVG_2km(self,Bean_2km, DrivingRequired):
        self.Temp_AVG_2km[Bean_2km] = round(self.Temp_AVG,1)
        lMin = min(self.Temp_AVG_2km)
        lMax = max(self.Temp_AVG_2km)
        self.Temp_AVG_2km_Diff = round(lMax - lMin,1)

        #turn off thermally stable if it goes above 10°C or there is a temperature warning
        #turn it back on if there are no temperature warnings and the diff temp is  below 5°C
        #no temperature warnings and maintained less than 5°C variation in the last 2km of driving
        if self.Temp_AVG_2km_ThermallyStable == 1 and self.Temp_AVG_2km_Diff > self.Thermal_Stability_Off:
            self.Temp_AVG_2km_ThermallyStable = 0
        elif self.Temp_AVG_2km_ThermallyStable == 0 and self.Temp_AVG_2km_Diff <= self.Thermal_Stability_On:
            self.Temp_AVG_2km_ThermallyStable = 1
            
        self.Temp_AVG_DrivingRequired = DrivingRequired

class cBuddy_Tyres():
    def __init__(self,Config):
        self.Temp_AVG_2km_Bean = cBeanCounter(20)
        self.Temp_IMO_MidPoint_Bean = cBeanCounter(15)
        self.Temp_IMO_MidPoint_Index = cBeanCounter(10)

        self.Tyres = [0,0,0,0]
        
        optimal_spread_front, optimal_spread_rear = Config.OptimalSpread
        thermal_stability_temps = Config.Thermal_Stability_Temps
        self.Tyres[cCAC.FRONT_LEFT]  = cBuddy_Tyre(20,10,"FL",cCAC.FRONT_LEFT ,cCAC.FRONT,cCAC.LEFTSIDE  , optimal_spread_front,thermal_stability_temps)
        self.Tyres[cCAC.FRONT_RIGHT] = cBuddy_Tyre(20,10,"FR",cCAC.FRONT_RIGHT,cCAC.FRONT,cCAC.RIGHTSIDE , optimal_spread_front,thermal_stability_temps)
        self.Tyres[cCAC.REAR_LEFT]   = cBuddy_Tyre(20,10,"RL",cCAC.REAR_LEFT  ,cCAC.REAR ,cCAC.LEFTSIDE  , optimal_spread_rear ,thermal_stability_temps)
        self.Tyres[cCAC.REAR_RIGHT]  = cBuddy_Tyre(20,10,"RR",cCAC.REAR_RIGHT ,cCAC.REAR ,cCAC.RIGHTSIDE , optimal_spread_rear ,thermal_stability_temps)

        #The code assumes these arrays are the same size
        self.Slips_Front_DIFF = [0] * 13
        self.Slips_Rear_DIFF  = [0] * 13

        #hard coded to MID for the time being
        self.Sensitivity = Config.Slips_Sensitivity
        self.Decay = Config.Slips_Decay

    #this is so you can call BuddyTyres[n] instead of BuddyTyres.Tyres[n]
    def __getitem__(self,index):
        return self.Tyres[index]

    def updateOptimalSpread(self,front,rear):
        for n in range(4):
            if n < 2:
                self.Tyres[n].OptimalSpread = front * 1.5
                self.Tyres[n].Half_OptimalSpread = self.Tyres[n].OptimalSpread / 2
            else:
                self.Tyres[n].OptimalSpread = rear * 1.5
                self.Tyres[n].Half_OptimalSpread = self.Tyres[n].OptimalSpread / 2

    def updateSlips(self,arSlips):
        lDIFF_Size = len(self.Slips_Front_DIFF)
        
        WS_FL = arSlips[0]
        WS_FR = arSlips[1]
        WS_RL = arSlips[2]
        WS_RR = arSlips[3]
        
        #abs(WS_FL - WS_FR) is roughly between 0 and 0.2;
        #so blow that up to 0-13 to get an index
        #and then boost the signal in a histogram
        DIFF_FRONT_INDEX = int(round(min(max(abs(WS_FL - WS_FR) * (lDIFF_Size*5) ,0),lDIFF_Size-1),0))
        self.Slips_Front_DIFF[DIFF_FRONT_INDEX] += round(lDIFF_Size/self.Sensitivity,0)

        DIFF_REAR_INDEX = int(round(min(max(abs(WS_RL - WS_RR) * (lDIFF_Size*5) ,0),lDIFF_Size-1),0))
        self.Slips_Rear_DIFF[DIFF_REAR_INDEX] += round(lDIFF_Size/self.Sensitivity,0)

        for i in range(lDIFF_Size):
            self.Slips_Front_DIFF[i] = min(max(self.Slips_Front_DIFF[i]-self.Decay,0),100)
            self.Slips_Rear_DIFF[i]  = min(max(self.Slips_Rear_DIFF[i] -self.Decay,0),100)

    def NewTyres(self):
        for n in range(4):
            self.Tyres[n].NewTyres()

    def update(self):
        #count the last N MidPoints to average them later
        #but only capture 10% of them, to smooth out the signal
        lMidPoint_Bean = bool(self.Temp_IMO_MidPoint_Bean)
        if lMidPoint_Bean:
            lMidPoint_Index = int(self.Temp_IMO_MidPoint_Index) # increment and get value
        else:
            lMidPoint_Index = self.Temp_IMO_MidPoint_Index.GetValue() # just get the value

        for n in range(4):
            self.Tyres[n].update(lMidPoint_Bean,lMidPoint_Index)

        #if stationary, update AVG_2km every 15 beans
        if lMidPoint_Bean and round(info.physics.speedKmh,0) == 0:
            self.UpdateAVG_2km(1)

        #3 of 15 updates instead of 1/15
        if self.Temp_IMO_MidPoint_Bean.GetValue() % 5 == 0:
            lARSlips = [ \
                  self.Tyres[cCAC.FRONT_LEFT ].Slip \
                , self.Tyres[cCAC.FRONT_RIGHT].Slip \
                , self.Tyres[cCAC.REAR_LEFT  ].Slip \
                , self.Tyres[cCAC.REAR_RIGHT ].Slip \
                ]
            self.updateSlips(lARSlips)

    def UpdateAVG_2km(self, DrivingRequired):
        #calculate 2km bean so that each tyre gets the same number all at the same time
        lBean_2km = int(self.Temp_AVG_2km_Bean)
        for n in range(4):
            self.Tyres[n].UpdateAVG_2km(lBean_2km, DrivingRequired)



