#copied and adapted from traces app
import os
import configparser
import ac
from TyreBuddy_lib.sim_info import info
from TyreBuddy_lib.RangeLUT import cRangeLUT

class cIMOStance:
    def __init__(self):
        self.IMOStanceIndex = 2
        self.IMOStanceData = [ \
             { "Rear":1.0, "Front":0.45, "Stance":"Super Freddo"     , "Label":"Super Freddo"     } \
            ,{ "Rear":1.0, "Front":0.7 , "Stance":"Freddo"           , "Label":"Freddo"           } \
            ,{ "Rear":1.0, "Front":1.0 , "Stance":"Equilibrato"      , "Label":"Equilibrato"      } \
            ,{ "Rear":0.8, "Front":1.3 , "Stance":"Aggressivo"       , "Label":"Aggressivo"       } \
            ,{ "Rear":0.7, "Front":1.6 , "Stance":"Super Aggressivo" , "Label":"Super Aggressivo" } \
            ]
    def __str__(self):
        return self.IMOStanceData[self.IMOStanceIndex]["Label"]
    def __repr__(self):
        return self.IMOStanceData[self.IMOStanceIndex]["Stance"]

    @property
    def Stance(self):
        return self.IMOStanceData[self.IMOStanceIndex]["Front"], self.IMOStanceData[self.IMOStanceIndex]["Rear"]

    def __int__(self):
        return self.IMOStanceIndex

    def PlusOne(self):
        if self.IMOStanceIndex < (len(self.IMOStanceData)-1):
            self.IMOStanceIndex += 1

    def MinusOne(self):
        if self.IMOStanceIndex > 0:
            self.IMOStanceIndex -= 1

    def SetIMOSpreadFromLabel(self,Label):
        lData = [n for n, e in enumerate(self.IMOStanceData) if e["Stance"] == Label]
        lData = 2 if len(lData) == 0 else lData[0]
        self.IMOStanceIndex = lData

class cIMOSpreads:
    def __init__(self):
        self.IMOStance = cIMOStance()
        self.IMOSpreadIndex = 0
        self.IMOSpreadData = [ \
             { "Spread": 2.5, "Label":"Vintage" }      \
            ,{ "Spread": 5.0, "Label":"Regolare" }     \
            ,{ "Spread": 7.5, "Label":"Esotico" }      \
            ,{ "Spread":10.0, "Label":"Gran Turismo" } \
            ,{ "Spread":12.5, "Label":"Formula" }      \
            ]
    def __str__(self):
        return self.IMOSpreadData[self.IMOSpreadIndex]["Label"]
    def __repr__(self):
        return self.IMOSpreadData[self.IMOSpreadIndex]["Label"]

    @property
    def Spread(self):
        imo_spread_front = self.IMOSpreadData[self.IMOSpreadIndex]["Spread"]
        imo_spread_rear = imo_spread_front
        stance_front, stance_rear = self.IMOStance.Stance
        imo_spread_front *= stance_front
        imo_spread_rear *= stance_rear
        
        return imo_spread_front, imo_spread_rear

    def __float__(self):
        return self.IMOSpreadData[self.IMOSpreadIndex]["Spread"]

    def __int__(self):
        return self.IMOSpreadIndex

    def PlusOne(self):
        if self.IMOSpreadIndex < (len(self.IMOSpreadData)-1):
            self.IMOSpreadIndex += 1

    def MinusOne(self):
        if self.IMOSpreadIndex > 0:
            self.IMOSpreadIndex -= 1

    def SetIMOSpreadFromDegrees(self,Degrees):
        lData = [n for n, e in enumerate(self.IMOSpreadData) if e["Spread"] == Degrees]
        lData = 1 if len(lData) == 0 else lData[0]
        self.IMOSpreadIndex = lData

    def SetIMOSpreadFromLabel(self,Label):
        lData = [n for n, e in enumerate(self.IMOSpreadData) if e["Label"] == Label]
        lData = 1 if len(lData) == 0 else lData[0]
        self.IMOSpreadIndex = lData

class cBuddyPage:
    def __init__(self):
        self.PageIndex = 0
        self.PageData = [ \
             { "Page":"OFF"  , "Label":""      } \
            ,{ "Page":"AUTO" , "Label":"Auto"  } \
            ,{ "Page":"TEMPS", "Label":"Temps" } \
            ,{ "Page":"PSI"  , "Label":"PSI"   } \
            ,{ "Page":"IMO"  , "Label":"IMO"   } \
            ,{ "Page":"FUEL" , "Label":"Fuel"  } \
            ]
    def __str__(self):
        return self.PageData[self.PageIndex]["Label"]
    def __repr__(self):
        return self.PageData[self.PageIndex]["Page"]
    def __int__(self):
        return self.PageIndex

    def PlusOne(self):
        if self.PageIndex < (len(self.PageData)-1):
            self.PageIndex += 1

    def MinusOne(self):
        if self.PageIndex > 0:
            self.PageIndex -= 1

    def SetPageFromPage(self,Page):
        lData = [n for n, e in enumerate(self.PageData) if e["Page"] == Page.upper()]
        lData = 1 if len(lData) == 0 else lData[0]
        self.PageIndex = lData

    def SetPageFromLabel(self,Label):
        lData = [n for n, e in enumerate(self.PageData) if e["Label"] == Label]
        lData = 1 if len(lData) == 0 else lData[0]
        self.PageIndex = lData

class cBuddyWear:
    def __init__(self):
        self.WearIndex = 0
        self.BalanceData = [ \
             { "Page":"LEVEL1" , "Label":"Squashed" } \
            ,{ "Page":"LEVEL2" , "Label":"Compressed" } \
            ,{ "Page":"LEVEL3" , "Label":"Normal"  } \
            ]
    def __str__(self):
        return self.BalanceData[self.WearIndex]["Label"]
    def __repr__(self):
        return self.BalanceData[self.WearIndex]["Page"]
    def __int__(self):
        return self.WearIndex

    def PlusOne(self):
        if self.WearIndex < (len(self.BalanceData)-1):
            self.WearIndex += 1

    def MinusOne(self):
        if self.WearIndex > 0:
            self.WearIndex -= 1

    def SetPageFromPage(self,Page):
        lData = [n for n, e in enumerate(self.BalanceData) if e["Page"] == Page.upper()]
        lData = 1 if len(lData) == 0 else lData[0]
        self.WearIndex = lData

    def SetPageFromLabel(self,Label):
        lData = [n for n, e in enumerate(self.BalanceData) if e["Label"] == Label]
        lData = 1 if len(lData) == 0 else lData[0]
        self.WearIndex = lData

class Config:
    """App configuration. Load config upon intialization."""
    def __init__(self):
        # Set up config paths
        self.lib_dir = os.path.dirname(__file__)
        self.app_dir = os.path.join(self.lib_dir,"../")
        self.cfg_file_path = os.path.join(self.app_dir, "config.ini")
        self.defaults_file_path = os.path.join(self.app_dir, "config_defaults.ini")
        self.BuddyPage = cBuddyPage()
        self.IMOSpreads = cIMOSpreads()
        self.WearLevels = cBuddyWear()
        self.TYRE_IMO_COLOURS_FRONT = [0,0,0]
        self.TYRE_IMO_COLOURS_REAR  = [0,0,0]

        # Set app attributes that are non-configurable by user, 
        # which therefore don't appear in the config file.
        self.app_name = "Tyre Buddy"
        self.Slips_Sensitivity = 1
        self.Slips_Decay = 2
        self.Car_CurrentTyres_OptimalCold = 0
        self.Car_CurrentTyres_OptimalHot = 0
        
        self.isTouristenfahrten = (
            #info.static returns the previous session data when called from __init__
            #so we are using ac.getTrack____ instead
            ac.getTrackName(0).lower() == "ks_nordschleife"
            and
            ac.getTrackConfiguration(0).lower()[:16] == "touristenfahrten"
            )

        self.DEBUG = ""
        
        # Load config
        self.update_cfg = False
        try:
            self.load()
        except:
            #if the config fails to load, delete the config file and try again
            #this can happen if MedianLine is side-by-side with medianline.
            os.remove(self.cfg_file_path)
            #if it fails again, well tough really
            self.load()

    def ResizeWindow(self,Multiply):
        self.Resolution = Multiply
        self.app_height = round(150 * Multiply,0)
        self.app_width = round(230 * Multiply,0)
        self.GaugeWidth = round(6 * Multiply,0)
        self.BoxWidth = round(self.app_width * (10/23),0)
        self.BoxWidth -= self.GaugeWidth
        self.BoxHeight = round(self.app_height / 3,0)
        self.VerticalPadding = self.BoxWidth / 10
        self.HorizontalPadding = self.BoxWidth / 10

    @property
    def OptimalSpread(self):
        return self.IMOSpreads.Spread

    @property
    def Thermal_Stability_Temps(self):
        return [ self.Thermal_Stability_On, self.Thermal_Stability_Off ]

    @property
    def TrackGripLevel(self):
        return info.graphics.surfaceGrip

    def ReadFile(FullFilePath):
        lContent = ""
        with open(FullFilePath,"r") as file:
            lContent = file.read()
        return lContent

    def ReadSectionParameter(self,cp,section,option):
        lData = 0
        if option == "front_optimum_cold":
            lData = self.OptimalCold
        elif option == "front_optimum_hot":
            lData = self.OptimalHot
        if cp.has_section(section) and cp.has_option(section,option):
            if option in["front_wear","rear_wear"]:
                lData = str(cp[section][option])
            else:
                lData = int(cp[section][option])
        return lData

    def LoadCarData(self,CarName,Compound):
        lCARINI = "{}.ini".format(CarName)
        lCarConfig_dir = os.path.join(os.path.join(self.app_dir,"TyreBuddy_config"),lCARINI)
        if not os.path.exists(lCarConfig_dir):
            self.Car_CurrentTyres_OptimalCold = self.OptimalCold
            self.Car_CurrentTyres_OptimalHot = self.OptimalHot
        else:
            lFileContent = Config.ReadFile(lCarConfig_dir)
            cpCarINI = configparser.ConfigParser(empty_lines_in_values=False, inline_comment_prefixes=(";",))
            cpCarINI.read_string(lFileContent)
            #front and rear optimum values are ALWAYS the same for KUNOS cars
            #mod cars are not supported currently
            self.Car_CurrentTyres_OptimalCold   = self.ReadSectionParameter(cpCarINI,Compound,"front_optimum_cold")
            self.Car_CurrentTyres_OptimalHot    = self.ReadSectionParameter(cpCarINI,Compound,"front_optimum_hot")
            self.Car_CurrentTyres_FrontWear     = self.ReadSectionParameter(cpCarINI,Compound,"front_wear")
            self.Car_CurrentTyres_RearWear      = self.ReadSectionParameter(cpCarINI,Compound,"rear_wear")

    def CalculateTyres(self,CarName,Compound):
        self.LoadCarData(CarName,Compound)
            
        #Limit cold warning to 20°C minimum
        self.Absolute_ColdWarning = max(self.Car_CurrentTyres_OptimalCold - (self.Cold_Warning*2),20)
        self.Absolute_HotWarning = self.Car_CurrentTyres_OptimalHot + self.Hot_Warning1
        self.Absolute_Hottest = self.Car_CurrentTyres_OptimalHot + self.Hot_Warning2

        #TYRE_TEMP LUTS RAINBOW
        lAbsolute_Hot_Warning1 = self.Car_CurrentTyres_OptimalHot + self.Hot_Warning1
        lAbsolute_Hot_Warning2 = self.Car_CurrentTyres_OptimalHot + self.Hot_Warning2
        lBlueHalfWay = ((self.Car_CurrentTyres_OptimalCold - self.Absolute_ColdWarning) / 2) + self.Absolute_ColdWarning
        self.TYRE_TEMP_COLOURS = [0,0,0]
        self.TYRE_TEMP_COLOURS[2] = cRangeLUT("{T1}=1|{T2}=0".format(T1=lBlueHalfWay,T2=self.Car_CurrentTyres_OptimalCold))
        self.TYRE_TEMP_COLOURS[1] = cRangeLUT("{T1}=0|{T2}=1|{T3}=1|{T4}=0".format(T1=self.Absolute_ColdWarning,T2=lBlueHalfWay,T3=self.Absolute_HotWarning,T4=self.Absolute_Hottest))
        self.TYRE_TEMP_COLOURS[0] = cRangeLUT("{T1}=0|{T2}=1".format(T1=self.Car_CurrentTyres_OptimalHot,T2=self.Absolute_Hottest))

    def load(self):
        """Initialize config parser and load config"""
        # Load config file parser
        self.cfg_parser = configparser.ConfigParser()
        self.cfg_parser.read(self.cfg_file_path)
        # Load config defaults file parser
        self.defaults_parser = configparser.ConfigParser(inline_comment_prefixes=";")
        self.defaults_parser.read(self.defaults_file_path)

        # Loop over sections in defaults. If any are missing in cfg, add them.
        for section in self.defaults_parser.sections():
            if not self.cfg_parser.has_section(section):
                self.cfg_parser.add_section(section)
                
        # Load attributes from config.
        # If option is missing, get option from defaults and replace
        self.getstr('COLOURS', 'MedianLine')
        
        self.getint('TYRE_PSI', 'Warning_PSI_Low')
        self.getint('TYRE_PSI', 'Warning_PSI_High')
        self.getstr('TYRE_PSI', 'PSI_Text_Warning')

        self.getstr('SETTINGS', 'Resolution')
        self.getstr('SETTINGS', 'Optimal_Spread')
        self.getstr('SETTINGS', 'Page')
        self.getstr('SETTINGS', 'IMOStance')
        self.getint('SETTINGS', 'Warm_Up_KMs')
        self.getint('SETTINGS', 'After_Spin_KMs')
        
        self.getint('SETTINGS', 'Thermal_Stability_Range')
        self.getint('SETTINGS', 'Thermal_Stability_Fluff')
        
        self.getstr('SETTINGS', 'Wear_Level')

        if self.Resolution == '1080p':
            self.ResizeWindow(1.5)
        elif self.Resolution == '1440p':
            self.ResizeWindow(2)
        elif self.Resolution == '4K':
            self.ResizeWindow(3)
        else:
            self.ResizeWindow(1)

        # Turn off the Warning when Thermal Stability comes under this number
        self.Thermal_Stability_On = self.Thermal_Stability_Range
        # When Thermal Stability goes above this number turn on the warning
        self.Thermal_Stability_Off = self.Thermal_Stability_On + self.Thermal_Stability_Fluff
        
        self.BuddyPage.SetPageFromPage(self.Page)
        self.IMOSpreads.SetIMOSpreadFromLabel(self.Optimal_Spread)
        self.IMOSpreads.IMOStance.SetIMOSpreadFromLabel(self.IMOStance)
        self.updateOptimalSpread()
        self.WearLevels.SetPageFromPage(self.Wear_Level)
        
        self.getfloat('TYPE_TEMPS', 'OptimalCold')
        self.getfloat('TYPE_TEMPS', 'OptimalHot')
        self.getfloat('TYPE_TEMPS', 'Hot_Warning1')
        self.getfloat('TYPE_TEMPS', 'Hot_Warning2')
        self.getfloat('TYPE_TEMPS', 'Cold_Warning')
        
        self.getstr('TYRE_SLIPS','SLIP_REFRESH_RATE')

        if self.Hot_Warning2 < 10:
            self.setValue('TYPE_TEMPS', 'Hot_Warning2' , 5)

        if self.Hot_Warning1 < 5:
            self.setValue('TYPE_TEMPS', 'Hot_Warning1' , 2.5)

        #if self.Hot_Warning1 > self.Hot_Warning2:
        #    self.setValue('TYPE_TEMPS', 'Hot_Warning1' , round(self.Hot_Warning2 / 2))

        if self.OptimalHot < 50:
            self.setValue('TYPE_TEMPS', 'OptimalHot' , 50)

        if self.OptimalCold < 25:
            self.setValue('TYPE_TEMPS', 'OptimalCold' , 25)

        #if self.OptimalCold > self.OptimalHot:
        #    self.setValue('TYPE_TEMPS', 'OptimalCold' , round(self.OptimalHot - 15))

        # If update_cfg has been triggered (set to True), run save to update file.
        if self.update_cfg:
            self.save()

        lCarName = ac.getCarName(0)
        lCompound = ac.getCarTyreCompound(0) ## SHORT NAME
        self.CalculateTyres(lCarName,lCompound)

        #SLIP_REFRESH_RATE
        if self.SLIP_REFRESH_RATE.upper() == 'LOW':
            self.Slips_Sensitivity = 1
            self.Slips_Decay = 2
        elif self.SLIP_REFRESH_RATE.upper() == 'HIGH':
            self.Slips_Sensitivity = 0.5
            self.Slips_Decay = 3
        else: #default to MID
            self.Slips_Sensitivity = 1
            self.Slips_Decay = 1

    def Navigate(self,setting,direction):
        if setting == "OptimalSpread":
            if direction > 0:
                self.IMOSpreads.PlusOne()
            elif direction < 0:
                self.IMOSpreads.MinusOne()
            self.updateOptimalSpread()
            
            self.setValue('SETTINGS', 'Optimal_Spread' , repr(self.IMOSpreads))
        elif setting == "IMOStance":
            if direction > 0:
                self.IMOSpreads.IMOStance.PlusOne()
            elif direction < 0:
                self.IMOSpreads.IMOStance.MinusOne()
            self.updateOptimalSpread()
            
            self.setValue('SETTINGS', 'IMOStance' , repr(self.IMOSpreads.IMOStance))
        elif setting == "Page":
            if direction > 0:
                self.BuddyPage.PlusOne()
            elif direction < 0:
                self.BuddyPage.MinusOne()
            
            self.setValue('SETTINGS', 'Page' , repr(self.BuddyPage))
        elif setting == "Wear":
            if direction > 0:
                self.WearLevels.PlusOne()
            elif direction < 0:
                self.WearLevels.MinusOne()
            
            self.setValue('SETTINGS', 'Wear_Level' , repr(self.WearLevels))

        if self.update_cfg:
            self.save()

    def IMOColours(self,IMOSpread,IMO_COLOURS):
        #IMO BAR LUT RAINBOW
        lTOS = IMOSpread / 2
        lT1 = lTOS * 0.8
        lT2 = lTOS
        lT3 = lTOS + 1
        lT4 = lTOS + 2
        IMO_COLOURS[2] = cRangeLUT("-5=1|0=1|{T1}=0".format(T1=lT1))
        IMO_COLOURS[1] = cRangeLUT("0=0|{T1}=1|{T2}=1|{T3}=1|{T4}=0".format(T1=lT1,T2=lT2,T3=lT3,T4=lT4))
        IMO_COLOURS[0] = cRangeLUT("{T2}=0|{T3}=1".format(T2=lT2,T3=lT3))

    def updateOptimalSpread(self):
        front_imo_spread, rear_imo_spread = self.IMOSpreads.Spread
        self.IMOColours(front_imo_spread,self.TYRE_IMO_COLOURS_FRONT)
        self.IMOColours(rear_imo_spread ,self.TYRE_IMO_COLOURS_REAR )

    def save(self):
        """Save config file"""
        with open(self.cfg_file_path, 'w') as cfgfile:
            self.cfg_parser.write(cfgfile)
        self.update_cfg = False

    def setValue(self, section, option, value):
        self.__setattr__(option, value)
        self.cfg_parser.set(section, option, str(value))
        self.update_cfg = True

    def getfloat(self, section, option):
        """Get float variable from config.

        If missing from config, grab from defaults and save it to config.

        Args:
            section (str): Section in config file
            options (str): Option with specified section
        """
        try:
            value = self.cfg_parser.getfloat(section, option)
        except:
            value = self.defaults_parser.getfloat(section, option)
            self.cfg_parser.set(section, option, str(value))
            self.update_cfg = True
        self.__setattr__(option, value)


    def getbool(self, section, option):
        """Get boolean variable from config.

        If missing from config, grab from defaults and save it to config.

        Args:
            section (str): Section in config file
            options (str): Option with specified section
        """        
        try:
            value = self.cfg_parser.getboolean(section, option)
        except:
            value = self.defaults_parser.getboolean(section, option)
            self.cfg_parser.set(section, option, str(value))
            self.update_cfg = True
        self.__setattr__(option, value)


    def getint(self, section, option):
        """Get integer variable from config.

        If missing from config, grab from defaults and save it to config.

        Args:
            section (str): Section in config file
            options (str): Option with specified section
        """        
        try:
            value = self.cfg_parser.getint(section, option)
        except:
            try:
                value = int(self.cfg_parser.getfloat(section, option))
            except:
                value = self.defaults_parser.getint(section, option)
            self.cfg_parser.set(section, option, str(value))
            self.update_cfg = True
        self.__setattr__(option, value)


    def getstr(self, section, option):
        """Get string variable from config.

        If missing from config, grab from defaults and save it to config.

        Args:
            section (str): Section in config file
            options (str): Option with specified section
        """
        try: 
            value = self.cfg_parser.get(section, option)
        except:
            value = self.defaults_parser.get(section, option)
            self.cfg_parser.set(section, option, str(value))
            self.update_cfg = True
        self.__setattr__(option, value)
